
from keras.layers import Input, Dense, Convolution1D, MaxPooling1D, UpSampling1D, Flatten, Lambda, Reshape
from keras.models import load_model, Model
from keras.preprocessing.image import ImageDataGenerator
import os, glob
from keras import backend as K
import numpy as np
from keras.utils import plot_model
from sklearn import cluster, metrics
def fixed_generator(generator):
    for batch in generator:
        yield (batch, batch)

# dimensions of our images.
train_data_dir = r'F:\Programming\Python\AE\su_jz for cluster2.csv'
output_dir = "F:\Programming\Python\AE\jz_ac\\"
model_1_dir = r'F:\Programming\Python\AE\cov_autoencoder_model_f1f2_h7_3-3.h5'

nb_epoch = 300
latent_dim = 7
 
intermediate_dim = 96
original_dim = 168*2
epsilon_std = 1.0
#batch_size = 5 
#batch_size = int(batch_size)

nclusters = 5

# train_data for autoencoder01, autoencoder02
def load_data(filePath):
    train_data01 = []
    train_data02 = []
    with open(filePath,'r+') as f:
        for line in f:
            pData = line.strip().split(",")
            pData = np.reshape(pData, (168, 1)).astype(float)
            p_max = np.max(pData)
            train_data01.append(pData/(p_max+10e-9))
            train_data02.append(pData)
            
    train_data01 = np.array(train_data01) 
    train_data02 = np.array(train_data02)
    
    zmax_train02 = train_data02.max(axis = 0)
    train_data02 = train_data02/(zmax_train02+10e-9)
    
    a = train_data02.max(axis = 1)
    train = [train_data02[i]/(a[i]+10e-9) for i in range(train_data02.shape[0])]
    train = np.reshape(train,(train_data02.shape[0],-1,1))
    
    data = np.hstack((train_data01, train))
    #train_data = train
    return data
      
train_data = load_data(train_data_dir)

latent_size = (latent_dim,)
output_shape = (1, 42, 48)


# autoencoder_norm_1
vae = load_model(model_1_dir)

encoder = Model(vae.input, vae.get_layer('z').output)
encoder_1_out = encoder.predict(train_data)
#np.savetxt('%s%s'%(output_dir, 'encoder_1_out.csv'), encoder_1_out,  fmt="%s", delimiter = ',')
########################################################

# kmeans
kmeans = cluster.KMeans(n_clusters = nclusters)
kmeans.fit(encoder_1_out)
y_cls = kmeans.labels_
y_centers = kmeans.cluster_centers_
np.savetxt('%s%s'%(output_dir, '1_cls.csv'), y_cls,  fmt="%s", delimiter = ',')
np.savetxt('%s%s'%(output_dir,'1_center.csv'), y_centers,  fmt="%s", delimiter = ',')

score = metrics.calinski_harabaz_score(encoder_1_out, y_cls)
score1 = metrics.silhouette_score(encoder_1_out, y_cls)
print("method1 clusters value is %f\t%f\n" % (score, score1))

# spectral
#spectral = cluster.SpectralClustering(n_clusters = nclusters)
#spectral.fit(encoder_1_out)
#y_cls = spectral.labels_.astype(np.int)
#np.savetxt('%s%s'%(output_dir, '1_clsSpectral.csv'), y_cls,  fmt="%s", delimiter = ',')

# circle for kmeans
for n in range(2,20):
    kmeans = cluster.KMeans(n_clusters = n)
    kmeans.fit(encoder_1_out)
    score = metrics.calinski_harabaz_score(encoder_1_out,kmeans.labels_)
    score1 = metrics.silhouette_score(encoder_1_out,kmeans.labels_)
    print("%d clusters kmeans value is %f\t%f" % (n, score, score1))


